#!/usr/bin/python

# 2021-12, Christian Wirtz <doc@snowheaven.de>
# (always OK) checkmk local checks to track pihole values

# curl -s http://localhost:81/admin/api.php | jq

# (u'reply_IP', '->', 15988)
# (u'dns_queries_today', '->', 633820)
# (u'queries_cached', '->', 545948)
# (u'clients_ever_seen', '->', 37)
# (u'dns_queries_all_types', '->', 633768)
# (u'reply_NODATA', '->', 10025)
# (u'ads_percentage_today', '->', 1.01685)
# (u'ads_blocked_today', '->', 6445)
# (u'domains_being_blocked', '->', 100592)
# (u'status', '->', u'enabled')
# (u'gravity_last_updated', '->', {u'relative': {u'hours': 0, u'minutes': 41, u'days': 0}, u'file_exists': True, u'absolute': 1640551670})
# (u'unique_domains', '->', 2067)
# (u'unique_clients', '->', 37)
# (u'reply_NXDOMAIN', '->', 2434)
# (u'reply_CNAME', '->', 2825)
# (u'privacy_level', '->', 0)

import urllib2
import json

servicePrefix = 'Pi-hole'
uri = 'http://localhost:81/admin/'

#try:
url = uri + 'api.php'
result = urllib2.urlopen(url, timeout = 5).read()
json = json.loads(result)

for key in json:
    try:
        serviceName = '%s_%s' % (servicePrefix, key)
        txt = ''

        if key == 'gravity_last_updated':
            gravity_last_updated_line = json[key]
            # (u'relative', {u'hours': 1, u'minutes': 6, u'days': 0})
            # (u'file_exists', True)
            # (u'absolute', 1640554202)

            # (u'relative', {u'hours': 1, u'minutes': 6, u'days': 0})
            hours = gravity_last_updated_line['relative']['hours']
            minutes = gravity_last_updated_line['relative']['minutes']
            days = gravity_last_updated_line['relative']['days']

            gravity_last_updated_relative = minutes*60 + hours*60*60 + days*24*60*60

            txt = 'last update: %s days, %s hours, %s minutes ago' % (days, hours, minutes)
            txt += ', absolute: %s' % gravity_last_updated_line['absolute']
            txt += ', file_exists: %s' % gravity_last_updated_line['file_exists']

            perfdata = 'gravity_last_updated_absolute=%s|gravity_last_updated_relative=%s' % (gravity_last_updated_line['absolute'], gravity_last_updated_relative)
            json[key] = ''
        else:
            if type(json[key]) == int or float and key != 'status':
                unit = ''
                if key == 'ads_percentage_today':
                    unit = '%'
                perfdata = '%s=%s%s' % (key, json[key], unit)
            else:
                perfdata = '-'

        print('0 %s %s %s%s %s' % (serviceName, perfdata, json[key], unit, txt))

    except:
        print('3 %s - An error occurred during the request to the API.' % serviceName)

